//
//  ofxIPhoneAccelerometer.mm
//  openFrameworks
//
//  Created by Mehmet Akten on 09/01/2009.
//  Copyright 2009 MSA Visuals Ltd.. All rights reserved.
//

#import "ofxAccelerometer.h"

/************ Interface for iPhone Accelerometer Delegate ************/
@interface ofxIPhoneAccelerometerDelegate : NSObject <UIAccelerometerDelegate> {
}

@end

// define instance of delegate 
static ofxIPhoneAccelerometerDelegate* iPhoneAccelerometerDelegate;




/************ Impementation of standard C++ accel interface tailored for iPhone ************/
// call this to setup the accelerometer
void ofxAccelerometerHandler::setup() {
//	printf("ofxAccel::setup()\n");
	[iPhoneAccelerometerDelegate release];		// in case we've already called it for some reason
	iPhoneAccelerometerDelegate = [[ofxIPhoneAccelerometerDelegate alloc] init];
//	[[UIDevice currentDevice] beginGeneratingDeviceOrientationNotifications]; 

#if TARGET_IPHONE_SIMULATOR
	ofxAccelerometer.setSmooth(0);
	update(0, -1, 0);
#endif
}
	
// call this when accelerometer is no longer needed
void ofxAccelerometerHandler::exit() {
//	printf("ofxAccel::exit()\n");
	[iPhoneAccelerometerDelegate release];
}





/************ Implementation of iPhone Accelerometer Delegate ************/
@implementation ofxIPhoneAccelerometerDelegate

-(ofxIPhoneAccelerometerDelegate*) init {
	if(self = 	[super init]) {
		UIAccelerometer *accelerometer = [UIAccelerometer sharedAccelerometer];
		accelerometer.delegate = self;
		accelerometer.updateInterval = 1.0f/30.0f;
	}
	return self;
}


-(void) accelerometer:(UIAccelerometer *)accelerometer didAccelerate:(UIAcceleration*)accel {
	ofxAccelerometer.update(accel.x, accel.y, accel.z);
}

@end
