
#import "iPhoneAppDelegate.h"
#include "ofMain.h"



@implementation iPhoneAppDelegate


-(void) timerLoop {
	// create autorelease pool in case anything needs it
	NSAutoreleasePool * pool = [[NSAutoreleasePool alloc] init];
	
	iPhoneWindow->timerLoop();
	
	// release pool
	[pool release];
}



-(void) applicationDidFinishLaunching:(UIApplication *)application {    
	// get screen bounds
	CGRect	rect = [[UIScreen mainScreen] bounds];
	
	// create fullscreen window
	window = [[UIWindow alloc] initWithFrame:rect];
	
	// create the OpenGL view and add it to the window
	glView = [[EAGLView alloc] initWithFrame:rect pixelFormat:GL_RGB565_OES depthFormat:GL_DEPTH_COMPONENT16_OES preserveBackbuffer:NO];	
	[window addSubview:glView];
	
	// release glView (window still has retain on it)
	[glView release];
	
	// make window active
	[window makeKeyAndVisible];
	
	// save reference to ofAppiPhoneWindow for quick access
	iPhoneWindow = (ofAppiPhoneWindow*)ofAppWindow;
	
	// give baseApp reference to glView for touch callbacks
	[glView setApp:iPhoneWindow->baseApp];
	
	// give glView reference to iPhoneWindow
	iPhoneWindow->glView = glView;
	
	// gobe delegate reference to iPhoneWindow
	iPhoneWindow->appDelegate = self;
	
	// show or hide status bar depending on OF_WINDOW or OF_FULLSCREEN
	[[UIApplication sharedApplication] setStatusBarHidden:(iPhoneWindow->windowMode == OF_FULLSCREEN) animated:YES];

	// start timer
	[self setFrameRate:60];

	// call testApp::setup()
	iPhoneWindow->baseApp->setup();
}

-(void) setFrameRate:(float)frameRate {
	printf("setFPS\n");
	newFrameRate = frameRate;
	
//	if(timer) [timer invalidate];
	timer = [NSTimer scheduledTimerWithTimeInterval:(1.0f / newFrameRate) target:self selector:@selector(timerLoop) userInfo:nil repeats:YES];
	newFrameRate = 0;
}


-(void) dealloc {
    [window release];
//	[glView release];		// we dont need to release this, window will
    [super dealloc];
}




-(void) applicationWillResignActive:(UIApplication *)application {
	// add lostFocus() to baseApp?
}


-(void) applicationDidBecomeActive:(UIApplication *)application {
	// add gotFocus() to baseApp?
}


-(void) applicationWillTerminate:(UIApplication *)application {
	[timer invalidate];
	iPhoneWindow->baseApp->exit();
	delete iPhoneWindow->baseApp;
}


-(void) applicationDidReceiveMemoryWarning:(UIApplication *)application {
	// add callback for this
}


@end
